      FUNCTION COMMA(I)
      CHARACTER*1 COMMA
      COMMA=','
      IF ((I.EQ.NIN()).OR.(I.EQ.NIN()+NOUT())) COMMA=' '
      RETURN
      END
 

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)    
      LOGICAL STRFON
      COMMON /STRFST/ XPARTN(2),BE(2),STRFON(2)
      COMMON /PVECT/ P(0:3,100)
      DIMENSION PP(0:3,10)
      CHARACTER*20 FILENAME
      CHARACTER*6 PINF
      LOGICAL FILEON
      COMMON /MCINTR/ NCALL0,ITMX0,FILEON,MDS0
      COMMON /RGNORM/ RNORM(0:200)
      EXTERNAL FUNC_RD
      COMMON /DEVICE/  IPRT,ISES,IBAT,ISTR(2),IEVENT,ITMP
      CHARACTER*1 COMMA
      LOGICAL FIRST,QUADRA 

      SAVE

      IEVENT= 15
      READ(*,FMT='(A20)') FILENAME
       OPEN(IEVENT,FILE=FILENAME, FORM='UNFORMATTED',STATUS='OLD',
     &  ERR=100)
      CALL VEGINI
      CALL RDCOMP(IEVENT,FIRST)
      CALL RDGRID(IEVENT)
      WRITE(6,FMT='(1x,10(A3,A1,1x))') (PINF(1,I),COMMA(I),I=1,NIN()),
     &' ->',' ',(PINF(1,I),COMMA(I), I=NIN()+1,NIN()+NOUT())

      CALL E_BEG
      QUADRA= .FALSE.

      CALL IMKMOM(QUADRA,NDIM,IERR)  
      DO 34 KREG=0,NNREG()
34    RNORM(KREG)=1

      DUMMY=SETBUF()
      CALL VEGNNN(NCALL0,MDS0)
      IF(FIRST) THEN
        call vegas(ndim,func_RD,avgi,sd,chi2A)
      ELSE 
        call vegas1(ndim,func_RD,avgi,sd,chi2A)
      ENDIF
*       CALL  VEGPRN(6,.FALSE.,AVGI,SD,CHI2A)

      DO 23 I=2,ITMX0
        CALL  VEGAS3(NDIM,FUNC_RD,AVGI,SD,CHI2A)
23      CONTINUE
      READ(IEVENT)  ( (PP(I,J),I=0,3),J=1,NIN()+NOUT())
      CALL E_END

      DIFF=0
      DO 30 I=0,3  
      DO 30 J=1,NIN()+NOUT()
30    DIFF=DIFF+ ABS(PP(I,J) - P(I,J))

      SUMM=0
      DO 31 J=1,NIN()
31    SUMM=SUMM + ABS(PP(0,J))
      IF (10.E10*DIFF.GT.SUMM)STOP 'ERROR IN BINARY FILE'

      STOP
100   STOP ' INPUT FILE IS ABSENT'
      END

      FUNCTION FUNC_RD(X,WGT)      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(10)
      LOGICAL FILEON
      COMMON /MCINTR/ NCALL0,ITMX0,FILEON,MDS0      
      COMMON/PVECT/P(0:3,100)
      REAL  *  4 BUFF(500)
      COMMON /DEVICE/  IPRT,ISES,IBAT,ISTR(2),IEVENT,ITMP

      DATA NBUF/501/

      SAVE
      IF(NBUF.GT.500) THEN
        READ(IEVENT) BUFF
        NBUF=1
      ENDIF
      
      NIN1=NIN()+1
      NTOT=NIN()+NOUT()
      FUNC_RD=BUFF(NBUF)
      CALL MKMOM(X,FACTOR)
      CALL  LORROT
      IF(FUNC_RD.NE.0) CALL E_CALL(FUNC_RD*WGT/ITMX0, P)
      NBUF=NBUF+1
      RETURN
      ENTRY SETBUF
         NBUF=501
         SETBUF=0
         RETURN
      END
     

      FUNCTION NIN()
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*6,PNAME_
      COMMON /SERVIS/NIN_,NOUT_,PMAS_(10),PNAME_(10)
      SAVE
      NIN=NIN_
      RETURN
      END

      FUNCTION NOUT()
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*6,PNAME_
      COMMON /SERVIS/NIN_,NOUT_,PMAS_(10),PNAME_(10)
      
      SAVE

      NOUT=NOUT_
      RETURN
      END

      FUNCTION LENR()
      LENR=8
      RETURN
      END
      
      SUBROUTINE PMAS(NSUB,NPART,VALUE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*6,PNAME_                                      
      COMMON /SERVIS/NIN_,NOUT_,PMAS_(10),PNAME_(10)

      SAVE

      VALUE=PMAS_(NPART)
      RETURN
      END

      FUNCTION PINF(NSUB,NPART)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)                     
      CHARACTER*6 PNAME_
      COMMON /SERVIS/NIN_,NOUT_,PMAS_(10),PNAME_(10)
      CHARACTER*6 PINF
      SAVE
      PINF=PNAME_(NPART)
      RETURN
      END

      FUNCTION INDX(K,L)
      I=MIN(K,L)
      J=MAX(K,L)
      INDX=I+(J-1)*(J-2)/2
      RETURN
      END

